package dev.inmo.postssystem.publishing.ktor.client

import dev.inmo.postssystem.core.publishing.repos.*
import dev.inmo.postssystem.publishing.ktor.publishingKeysRootRoute
import io.ktor.client.HttpClient
import io.ktor.client.features.websocket.WebSockets

class PublishingKeysRepoKtorClient private constructor (
    readPublishingKeysClient: ReadPublishingKeysRepoKtorClient,
    writePublishingKeysClient: WritePublishingKeysRepoKtorClient
) : PublishingKeysRepo, ReadPublishingKeysRepo by readPublishingKeysClient, WritePublishingKeysRepo by writePublishingKeysClient {
    constructor(
        baseUrl: String,
        subpath: String? = publishingKeysRootRoute,
        client: HttpClient = HttpClient {
            install(WebSockets)
        }
    ) : this (
        ReadPublishingKeysRepoKtorClient (
            subpath ?.let { "$baseUrl/$subpath" } ?: baseUrl,
            client
        ),
        WritePublishingKeysRepoKtorClient(
            subpath ?.let { "$baseUrl/$subpath" } ?: baseUrl,
            client
        )
    )
}