package com.insanusmokrassar.postssystem.publishing.ktor.server.publishing_keys_repo

import dev.inmo.postssystem.core.publishing.repos.PublishingKeysRepo
import dev.inmo.postssystem.publishing.ktor.publishingKeysRootRoute
import dev.inmo.micro_utils.ktor.server.configurators.ApplicationRoutingConfigurator
import io.ktor.routing.Route
import io.ktor.routing.route

private inline fun configurator(proxyTo: PublishingKeysRepo): Route.() -> Unit = {
    configureReadPublishingKeysRepoRoutes(proxyTo)
    configureWritePublishingKeysRepoRoutes(proxyTo)
}

fun Route.configurePublishingKeysRepoRoutes (
    proxyTo: PublishingKeysRepo,
    rootRoute: String? = publishingKeysRootRoute
) {
    rootRoute ?.also {
        route(it, configurator(proxyTo))
    } ?: configurator(proxyTo).invoke(this)
}

class PublishingKeysRepoRoutingConfigurator (
    private val proxyTo: PublishingKeysRepo,
    private val rootRoute: String? = publishingKeysRootRoute
) : ApplicationRoutingConfigurator.Element {
    override fun Route.invoke() {
        configurePublishingKeysRepoRoutes(proxyTo, rootRoute)
    }
}